#include <stdio.h>
#include "lpc2114.h"

#define _BV(x) 	(1<<(x))

#define BAUDRATE                  9600
#define BAUDRATEDIVISOR           (15000000/(BAUDRATE*16))

void pll_init()
{
  MAM_MAMTIM = 3;
  MAM_MAMCR = 2;

  SCB_PLLCFG = 0x24;
  SCB_PLLCON = 0x1;
  SCB_PLLFEED = 0xAA;
  SCB_PLLFEED = 0x55;
  while (!(SCB_PLLSTAT&0x0400));
  SCB_PLLCON = 0x3;
  SCB_PLLFEED = 0xAA;
  SCB_PLLFEED = 0x55;
}

void uart1_init(void)
{
  PCB_PINSEL0 |= 0x00010000;  
	PCB_PINSEL0 |= 0x00040000;  
  UART1_FCR = 1;

  //Set baudrate
  UART1_LCR |= 0x80; // DLAB = 1;
  UART1_DLL = BAUDRATEDIVISOR & 0x00ff;
  UART1_DLM = (BAUDRATEDIVISOR >> 8) & 0x00ff;
  UART1_LCR &= ~0x80; // DLAB = 0;

  //Set mode
  UART1_LCR = 0x03; //8 bit word length, 1 stop bit, No parity
}

unsigned char uart1_recv(void)
{
	if ((UART1_LSR & 0x01)==0) return 0;
	return UART1_RBR;
}


void uart1_send_byte(unsigned char byte)
{
  while(!(UART1_LSR & 0x20));
  UART1_THR = byte;
}

void uart1_send(const char *s)
{
	while (*s) {
		uart1_send_byte(*s);
		s++;
	}
}

int main(void)
{
	char c;
	char buf[32];
	
	pll_init();
	uart1_init();
	
	while (1) {
		c = uart1_recv();
		switch (c) {
			case 'a':
				uart1_send("a - Jazda w lewo\r\n");
				break;
			case 'w':
				uart1_send("w - Jazda w prawo\r\n");
				break;
			case 'd':
				uart1_send("d -Jazda prosto\r\n");
				break;			
			case 0:
				break;
			default:
				sprintf(buf, "#%d - Nieznane polecenie\r\n", c);
				uart1_send(buf);
				break;				
		}
	}
}
